/*
 *   IgniteServ, include/data.h
 *   Copyright (C) 2005 by those in Authors file
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef INCLUDED_data_h
#define INCLUDED_data_h

#ifndef INCLUDED_stdio_h
#include <stdio.h>        /* FILE * */
#define INCLUDED_stdio_h
#endif

#ifndef INCLUDED_sys_types_h
#include <sys/types.h>        /* time_t */
#define INCLUDED_sys_types_h
#endif

#ifndef INCLUDED_operserv_h
#include "operserv.h"
#define INCLUDED_operserv_h
#endif

/*
 * Prototypes
 */

void BackupDatabases(time_t unixtime);
int ReloadData();
FILE *CreateDatabase(char *name, char *info);

int WriteDatabases();
int WriteOpers();
int WriteIgnores();
int WriteStats();
int WriteNicks();
int WriteChans();
int WriteMemos();

#ifdef SEENSERVICES
int WriteSeen();
#endif

void LoadData();
int ns_loaddata();
int cs_loaddata();
int ms_loaddata();
int ss_loaddata();
int os_loaddata();
int ignore_loaddata();

#ifdef SEENSERVICES
int es_loaddata();
#endif

#endif /* INCLUDED_data_h */
