/*
 *   IgniteServ, include/log.h
 *   Copyright (C) 2005 by those in Authors file
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef INCLUDED_log_h
#define INCLUDED_log_h

#ifndef INCLUDED_sys_types_h
#include <sys/types.h>        /* time_t */
#define INCLUDED_sys_types_h
#endif

/* Logging levels */

#define    LOG0    0  /* log nothing */
#define    LOG1    1  /* log security stuff - kills, admin commands etc */
#define    LOG2    2  /* same as 2, with some more events logged */
#define    LOG3    3  /* log all channel stuff as well */

void putlog(int level, char *format, ...);
void RecordCommand(char *format, ...);
void CheckLogs(time_t unixtime);

#endif /* INCLUDED_log_h */
