/*
 *   IgniteServ, include/sock.h
 *   Copyright (C) 2005 by those in Authors file
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef INCLUDED_sock_h
#define INCLUDED_sock_h

#ifndef INCLUDED_netinet_in_h
#include <netinet/in.h>         /* struct sockaddr_in */
#define INCLUDED_netinet_in_h
#endif

#ifndef INCLUDED_sys_types_h
#include <sys/types.h>         /* time_t */
#define INCLUDED_sys_types_h
#endif

#ifndef INCLUDED_conf_h
#include "conf.h"
#define INCLUDED_conf_h
#endif

#ifndef INCLUDED_config_h
#include "config.h"
#define INCLUDED_config_h
#endif

/* number of bytes to read from sockets - used to be 8192 */
#define BUFSIZE        16384

/* max parameters the hub can send us */
#define MAXPARAM       15

/*
 * Prototypes
 */

int writesocket(int sockfd, char *str);
void toserv(char *format, ...);
void tosock(int sockfd, char *format, ...);
void SetupVirtualHost();
struct hostent *LookupHostname(char *host, struct in_addr *ip_address);
int ConnectHost(char *hostname, unsigned int port);
int CompleteHubConnection(struct Servlist *hubptr);
void ReadSocketInfo(void);
int SetNonBlocking(int sockfd);
void SetSocketOptions(int sockfd);
void CycleServers();
void DoBinds();
void signon();

/*
 * External declarations
 */

extern int                      HubSock;
extern char                     *LocalHostName;
extern struct sockaddr_in       LocalAddr;

extern int read_socket_done;

#endif /* INCLUDED_sock_h */
